diff -Naur inkscape2/src/extension/internal/javafx-fxz.h inkscape/src/extension/internal/javafx-fxz.h
--- inkscape2/src/extension/internal/javafx-fxz.h	1970-01-01 01:00:00.000000000 +0100
+++ inkscape/src/extension/internal/javafx-fxz.h	2009-02-10 10:35:03.000000000 +0100
@@ -0,0 +1,178 @@
+/*
+ * JavaFX 1.0 plugin for Inkscape as a free extension to JavaFX Production Suite.
+ *
+ * The output is JavaFX 1.0 Content File (.fxz) and can be viewed by netbeans with
+ * FXD viewer plugin installed.
+ *  
+ *  For information on JavaFX Production Suite, see:
+ *      http://javafx.com/docs/gettingstarted/production_suite/
+ *
+ *  For information on the JavaFX file format, see:
+ *      https://openjfx.dev.java.net/
+ *      
+ * Based on the work of authors:
+ * 
+ *   Bob Jamison <ishmal@inkscape.org>
+ *   Silveira Neto <silveiraneto@gmail.com>
+ *   Jim Clarke <Jim.Clarke@sun.com>
+ *
+ * Copyright (C) 2008 Authors
+ *
+ * Updates:
+ *
+ *   Jan 2009 by Sergey Esenov <serguei.essenov@desy.de>
+ *
+ * Released under GNU GPL, read the file 'COPYING' for more information
+ */
+
+#ifndef EXTENSION_INTERNAL_JAVAFX_FXZ_H
+#define EXTENSION_INTERNAL_JAVAFX_FXZ_H
+
+#include <dom/dom.h>
+#include <dom/io/stringstream.h>
+#include <dom/uri.h>
+
+#include <glib.h>
+#include "extension/implementation/implementation.h"
+#include <document.h>
+#include <sp-gradient.h>
+#include <sp-filter.h>
+#include <sp-gaussian-blur.h>
+#include <sp-rect.h>
+#include <sp-ellipse.h>
+#include <sp-image.h>
+#include <sp-text.h>
+#include <sp-clippath.h>
+
+#include <string>
+#include <map>
+#include <vector>
+#include <zip.h>
+
+namespace Inkscape
+{
+namespace Extension
+{
+namespace Internal
+{
+
+// Use the same structures as in odf.h
+
+typedef org::w3c::dom::URI URI;
+typedef org::w3c::dom::io::Writer Writer;
+//========================= libzip1 based implementation
+typedef struct zip * ZipFile;
+typedef struct zip_source ZipEntry;
+
+
+/**
+ * Output the current SVG document in JavaFX content format.
+ * 
+ * For information, @see:  
+ * https://openjfx.dev.java.net/
+ */ 
+class JavaFXZ : public Inkscape::Extension::Implementation::Implementation
+{
+public:
+
+    typedef Glib::ustring String;
+    typedef SPGradient*   SPGradientPtr;
+    typedef SPFilter*     SPFilterPtr;
+    typedef SPClipPath*   SPClipPathPtr;
+
+    /**
+     * Check whether we can actually output using this module
+     */
+    virtual bool check (Inkscape::Extension::Extension * module);
+
+    /**
+     * API call to perform the output to a file
+     */
+    virtual void save (Inkscape::Extension::Output *mod, SPDocument *doc, const gchar *uri);
+
+    /**
+     * Inkscape runtime startup call.
+     */
+    static void init(void);
+	
+    /**
+     * Reset variables to initial state
+     */
+    void reset();
+	
+private:
+
+    URI documentUri;
+
+    std::map<Glib::ustring, SPGradientPtr> gradients;     // Gradient table
+    std::map<Glib::ustring, SPFilterPtr>   effects;       // Filter effect's table
+    std::map<Glib::ustring, SPClipPathPtr> clippaths;     // Clip path's table
+    std::map<Glib::ustring, Glib::ustring> imageTable;    // Images renaming table
+    std::vector<Glib::ustring> fontVector;                // file names of used fonts besides ...
+                                                          // ... Arial, SansSerif, Times Roman
+    SPItem *currentItem;     // Internal variable for keeping current item
+
+    //output class name
+    Glib::ustring name;
+    //For formatted output
+    Glib::ustring outbuf;   //main output buffer
+
+
+    /**
+     * Format text to our output buffer
+     */
+    void out(const char *fmt, ...) G_GNUC_PRINTF(2,3);
+
+    /**
+     * Output the file header
+     */
+    bool doHeader(SPDocument *doc);
+
+    /**
+     *  Output gradient information to the buffer
+     */
+    bool processGradient(SPGradient *grad);
+
+    /**
+     *  Output filter information to the buffer
+     */
+    bool processFilter(SPFilter *filter);
+
+    /**
+     *  Output clip-path information to the buffer
+     */
+    bool processClipPath(SPClipPath *clip);
+    bool doClipPath(SPClipPathReference *ref);
+
+    /**
+     *  Output an element's style attribute
+     */
+    bool doStyle(SPStyle *style);
+
+    /**
+     * Output the SVG document's curve data as JavaFX geometry types
+     */
+    bool doRect(SPRect *item, const Glib::ustring &id);
+    bool doCircle(SPGenericEllipse *item, const Glib::ustring& id);
+    bool doEllipse(SPGenericEllipse *item, const Glib::ustring& id);
+    bool doCurve(SPItem *item, const Glib::ustring& id);
+    bool doImage(ZipFile &zf, SPImage *image,    const String &id);
+    bool doText(ZipFile &zf, SPText *text,       const String &id);
+
+    bool processEffect(SPObject *obj);
+    bool generateClip(SPObject *obj);
+    bool traverseTree(ZipFile &zf, Inkscape::XML::Node *node);
+
+    /**
+     * Output the file footer
+     */
+    bool doTail();
+
+    bool saveDocument(SPDocument *doc, const gchar *uri);
+};
+
+}  // namespace Internal
+}  // namespace Extension
+}  // namespace Inkscape
+#endif /* EXTENSION_INTERNAL_JAVAFX_FXZ_H */
+
diff -Naur inkscape2/src/extension/internal/javafx-out.cpp inkscape/src/extension/internal/javafx-out.cpp
--- inkscape2/src/extension/internal/javafx-out.cpp	2009-02-12 10:39:35.000000000 +0100
+++ inkscape/src/extension/internal/javafx-out.cpp	2009-02-10 10:35:03.000000000 +0100
@@ -11,6 +11,9 @@
  *
  * Copyright (C) 2008 Authors
  *
+ * Updated 07 Jan 2009 by Sergey Esenov <sergey.esenov@gmail.com>
+ *   - Added support for gradients, texts, images.
+ *
  * Released under GNU GPL, read the file 'COPYING' for more information
  */
 
@@ -18,12 +21,20 @@
 #ifdef HAVE_CONFIG_H
 # include <config.h>
 #endif
-#include "javafx-out.h"
 #include <inkscape.h>
 #include <inkscape-version.h>
+#include <interface.h>
+#include <sp-root.h>
 #include <sp-path.h>
+#include <sp-rect.h>
+#include <sp-ellipse.h>
 #include <sp-linear-gradient.h>
 #include <sp-radial-gradient.h>
+#include <sp-gaussian-blur.h>
+#include <sp-filter.h>
+#include <sp-image.h>
+#include <sp-text.h>
+#include <text-editing.h>
 #include <style.h>
 #include <display/curve.h>
 #include <display/canvas-bpath.h>
@@ -42,6 +53,7 @@
 #include <stdio.h>
 #include <stdarg.h>
 
+#include "javafx-out.h"
 
 namespace Inkscape
 {
@@ -51,7 +63,8 @@
 {
 
 
-
+//# Shorthand notation
+typedef org::w3c::dom::DOMString DOMString;
 
 //########################################################################
 //# M E S S A G E S
@@ -84,11 +97,11 @@
 {
     double val = 1.0;
     for (SPObject const *obj = style->object; obj ; obj = obj->parent)
-        {
+    {
         style = SP_OBJECT_STYLE(obj);
         if (style)
             val *= SP_SCALE24_TO_FLOAT(style->opacity.value);
-        }
+    }
     return val;
 }
 
@@ -192,7 +205,7 @@
  */
 static JavaFXOutput::String sanatize(const JavaFXOutput::String &badstr){
     JavaFXOutput::String good(badstr);
-    for (int pos = 0; pos < badstr.length(); ++pos )
+    for (unsigned int pos = 0; pos < badstr.length(); ++pos )
         if((badstr.at(pos)=='-')||(badstr.at(pos)==' '))
             good.replace(pos, 1, "_");
     return good;
@@ -216,7 +229,7 @@
 /**
  * Output the file header
  */
-bool JavaFXOutput::doHeader()
+bool JavaFXOutput::doHeader(SPDocument *doc)
 {
     time_t tim = time(NULL);
     out("/*###################################################################\n");
@@ -228,7 +241,7 @@
     out("### NOTES:\n");
     out("### ============\n");
     out("### JavaFX information can be found at\n");
-    out("### hhttps://openjfx.dev.java.net\n");
+    out("### https://openjfx.dev.java.net\n");
     out("###\n");
     out("### If you have any problems with this output, please see the\n");
     out("### Inkscape project at http://www.inkscape.org, or visit\n");
@@ -241,21 +254,29 @@
     out("##==========================\n");
     out("##    Shapes   : %d\n", nrShapes);
     out("##    Nodes    : %d\n", nrNodes);
+    out("#####################################################################\n");
+    out("##   Document settings\n");
+    out("##==========================\n");
+    out("##    Document width  : %.3f\n", sp_document_height(doc));
+    out("##    Document height : %.3f\n", sp_document_height(doc));
     out("###################################################################*/\n");
     out("\n\n");
 
     // import javafx libraries we can need
-    out("import javafx.application.*;\n");
+    out("import javafx.stage.*;\n");
     out("import javafx.scene.*;\n");
-    out("import javafx.scene.geometry.*;\n");
+    out("import javafx.scene.shape.*;\n");
     out("import javafx.scene.transform.*;\n");
     out("import javafx.scene.paint.*;\n");
+    out("import javafx.scene.effect.*;\n");
+    out("import javafx.scene.text.*;\n");
+    out("import javafx.scene.image.*;\n");
     out("\n");
 
     out("\n\n");
 
     // Creates a class extended from CustomNode
-    out("public class %s extends CustomNode {\n", name.c_str());
+    out("class %s extends CustomNode {\n", name.c_str());
 
     return true;
 }
@@ -265,116 +286,142 @@
 /**
  *  Output the file footer
  */
-bool JavaFXOutput::doTail()
+bool JavaFXOutput::doTail(SPDocument *doc)
 {
     float border = 25.0;
+    double scaleX = 1.0;
+    double scaleY = 1.0;
+    double width  = sp_document_width ( doc );
+    double height = sp_document_height( doc );
+    
+    if (doc != NULL) {
+        SPRoot *root = SP_ROOT(doc->root);
+	if (root != NULL && root->viewBox_set) {
+	    scaleX = width  / (root->viewBox.x1 - root->viewBox.x0);
+	    scaleY = height / (root->viewBox.y1 - root->viewBox.y0);
+            if (scaleX != scaleY) {
+                scaleY = scaleX;
+	    }
+        }
+    }
 
     // Write the tail of CustomNode
-    out("           ] // content\n");
-    out("           transform: Translate { x : %s, y : %s }\n",
-	          DSTR((-minx) + border), DSTR((-miny) + border) );
-    out("       } // Group\n");
-    out("   } // function create()\n");
+    out("            ] // content\n");
+    out("            translateX : %.3f, translateY : %.3f\n", border, border );
+    out("            scaleX : %.3f, scaleY : %.3f\n", scaleX, scaleY);
+    out("        } // Group\n");
+    out("    } // function create()\n");
     out("} // class %s\n", name.c_str());
     out("\n");
 
     // Frame
-    out("Frame {\n");
+    out("Stage {\n");
     out("    title: \"%s\"\n", name.c_str());
-    out("    width: %s\n",  ISTR(maxx-minx + border * 2.0));
-    out("    height: %s\n", ISTR(maxy-miny + border * 2.0));
+    out("    width: %s\n",  ISTR(width  * scaleX + border * 2.0));
+    out("    height: %s\n", ISTR(height * scaleY + border * 2.0));
     out("    visible: true\n");
 
     // Stage
-    out("    stage: Stage {\n");
+    out("    scene: Scene {\n");
     out("        content: %s{}\n", name.c_str());
-    out("    } // Stage\n");
-
-    out("} // Frame\n");
-
-    out("\n");
+    out("    } // Scene\n");
 
+    out("} // Stage\n\n");
     out("/*###################################################################\n");
     out("### E N D   C L A S S    %s\n", name.c_str());
-    out("###################################################################*/\n");
-    out("\n\n");
+    out("###################################################################*/\n\n\n");
     return true;
 }
 
 
-
 /**
  *  Output gradient information to the buffer
  */
-bool JavaFXOutput::doGradient(SPGradient *grad, const String &id)
+bool JavaFXOutput::processGradient(SPGradient *grad)
 {
-    String jfxid = sanatize(id);
-
+    if (!grad) return true;
+    Geom::Matrix gt = grad->gradientTransform;
+    //char *transform_text = sp_svg_transform_write(gt);
     if (SP_IS_LINEARGRADIENT(grad))
-        {
+    {
         SPLinearGradient *g = SP_LINEARGRADIENT(grad);
-        out("    /* create LinearGradient for %s */\n", jfxid.c_str());
-        out("    private function %s(): LinearGradient {\n",  jfxid.c_str());
-        out("        LinearGradient {\n");
+	Geom::Matrix m1 = Geom::Matrix(Geom::Translate(g->x1.value, g->y1.value)) * gt;
+	Geom::Matrix m2 = Geom::Matrix(Geom::Translate(g->x2.value, g->y2.value)) * gt;
+	Geom::Point  p1 = m1.translation();
+	Geom::Point  p2 = m2.translation();
+
+        //g_free(transform_text);
+        out("                LinearGradient {\n");
+        out("                    startX: %.3f, startY: %.3f, endX: %.3f, endY: %.3f\n", p1[0], p1[1], p2[0], p2[1]);
+        if (SP_GRADIENT_UNITS(grad) == SP_GRADIENT_UNITS_USERSPACEONUSE)
+            out("                    proportional: false\n");
         std::vector<SPGradientStop> stops = g->vector.stops;
         if (stops.size() > 0)
-            {
-            out("            stops:\n");
-            out("                [\n");
+        {
+            out("                    stops: [\n");
             for (unsigned int i = 0 ; i<stops.size() ; i++)
-                {
+            {
                 SPGradientStop stop = stops[i];
-                out("                Stop {\n");
-                out("                    offset: %s\n", DSTR(stop.offset));
-                out("                    color: %s\n",  rgba(stop.color, stop.opacity).c_str());
-                out("                },\n");
-                }
-            out("            ]\n");
+                out("                        Stop { offset: %.3f, color: %s },\n", stop.offset, rgba(stop.color, stop.opacity).c_str());
             }
-        out("        };\n");
-        out("    } // end LinearGradient: %s\n", jfxid.c_str());
-        out("\n\n");
+            out("                    ]\n");
         }
+        out("                }\n");
+    }
     else if (SP_IS_RADIALGRADIENT(grad))
-        {
+    {
         SPRadialGradient *g = SP_RADIALGRADIENT(grad);
-        out("    /* create RadialGradient for %s */\n", jfxid.c_str());
-        out("    private function %s() {\n", jfxid.c_str());
-        out("        RadialGradient {\n");
-        out("            centerX: %s\n", DSTR(g->cx.value));
-        out("            centerY: %s\n", DSTR(g->cy.value));
-        out("            focusX: %s\n",  DSTR(g->fx.value));
-        out("            focusY: %s\n",  DSTR(g->fy.value));
-        out("            radius: %s\n",  DSTR(g->r.value ));
+	Geom::Matrix mc = Geom::Matrix(Geom::Translate(g->cx.value, g->cy.value)) * gt;
+        Geom::Matrix mf = Geom::Matrix(Geom::Translate(g->fx.value, g->fy.value)) * gt;
+        Geom::Matrix mr = Geom::Matrix(Geom::Scale(g->r.value, g->r.value)) * gt;
+	Geom::Point pc = mc.translation();
+        Geom::Point pf = mf.translation();
+        double rx = mr.expansionX();
+        double ry = mr.expansionY();
+        //g_free(transform_text);
+        out("                RadialGradient {\n");
+        out("                    centerX: %.3f, centerY: %.3f\n", pc[0], pc[1]);
+        out("                    focusX : %.3f, focusY : %.3f\n", pf[0], pf[1]);
+        // Use arithmetic mean value of rx and ry: javafx 1.0 doesn't support gradientTransform!
+        out("                    radius : %.3f\n", (rx+ry)/2.0);
+        if (SP_GRADIENT_UNITS(grad) == SP_GRADIENT_UNITS_USERSPACEONUSE)
+	    out("                    proportional: false\n"); 
         std::vector<SPGradientStop> stops = g->vector.stops;
         if (stops.size() > 0)
-            {
-            out("            stops:\n");
-            out("            [\n");
+        {
+            out("                    stops: [\n");
             for (unsigned int i = 0 ; i<stops.size() ; i++)
-                {
+            {
                 SPGradientStop stop = stops[i];
-                out("                Stop {\n");
-                out("                    offset: %s\n", DSTR(stop.offset));
-                out("                    color: %s\n",  rgba(stop.color, stop.opacity).c_str());
-                out("                },\n");
-                }
-            out("            ]\n");
+                out("                        Stop { offset: %.3f, color: %s },\n", stop.offset, rgba(stop.color, stop.opacity).c_str());
             }
-        out("        };\n");
-        out("    } // end RadialGradient: %s\n", jfxid.c_str());
-        out("\n\n");
+            out("                    ]\n");
         }
+        out("                }\n");
+    }
     else
-        {
-        err("Unknown gradient type for '%s'\n", jfxid.c_str());
+    {
+        //g_free(transform_text);
+        err("Unsupported gradient type\n");
         return false;
-        }
-
+    }
 
+    
     return true;
 }
 
+/**
+ *  Output filter information to the buffer
+ */
+bool JavaFXOutput::processFilter(SPFilter *filter)
+{
+    for (SPObject *child = filter->firstChild() ; child ; child = child->next)
+    {
+        if (!processEffect(child))
+            return false;
+    }
+    return true;
+}
 
 
 
@@ -386,28 +433,50 @@
     if (!style)
         return true;
 
-    out("            opacity: %s\n", DSTR(effective_opacity(style)));
+    out("            opacity: %.3f\n", effective_opacity(style));
 
     /**
      * Fill
      */
     SPIPaint fill = style->fill;
     if (fill.isColor())
-        {
+    {
         // see color.h for how to parse SPColor
         out("            fill: %s\n",
             rgba(fill.value.color, SP_SCALE24_TO_FLOAT(style->fill_opacity.value)).c_str());
-        }
-    else if (fill.isPaintserver()){
-        if (fill.value.href && fill.value.href->getURI() ){
+    }
+    else if (fill.isPaintserver()) {
+        if (fill.value.href && fill.value.href->getURI() ) {
             String uri = fill.value.href->getURI()->toString();
             /* trim the anchor '#' from the front */
             if (uri.size() > 0 && uri[0]=='#')
                 uri = uri.substr(1);
-            out("            fill: %s()\n", sanatize(uri).c_str());
+            SPGradient *grad = gradients[sanatize(uri)];
+            if (grad)
+                out("            fill:\n");
+            else
+                out("            fill: null\n");
+            if (!processGradient(grad))
+                return false;
         }
     }
+    else if (fill.isNoneSet())
+        out("            fill: null\n");
 
+    /**
+     * Filter
+     */
+    SPIFilter filter = style->filter;
+    if (filter.set) {
+        if (filter.href && filter.href->getURI()) {
+            String uri = filter.href->getURI()->toString();
+            if (uri.size() > 0 && uri[0]=='#')
+                uri = uri.substr(1);
+            SPFilter *filter = effects[sanatize(uri)];
+            if (!processFilter(filter))
+                return false;
+        }
+    }
 
     /**
      * Stroke
@@ -425,50 +494,154 @@
      * unsigned stroke_dashoffset_set : 1;
      * SPIScale24 stroke_opacity;
      */
-    if (style->stroke_opacity.value > 0)
-        {
+    if (!style->stroke.isNone() && style->stroke_opacity.value > 0)
+    {
         SPIPaint stroke = style->stroke;
         out("            stroke: %s\n",
             rgba(stroke.value.color, SP_SCALE24_TO_FLOAT(style->stroke_opacity.value)).c_str());
-        double strokewidth = style->stroke_width.value;
+        double strokewidth = style->stroke_width.computed;
         unsigned linecap   = style->stroke_linecap.value;
         unsigned linejoin  = style->stroke_linejoin.value;
-        out("            strokeWidth: %s\n",      DSTR(strokewidth));
-        out("            strokeLineCap: %s\n",    getStrokeLineCap(linecap).c_str());
-        out("            strokeLineJoin: %s\n",   getStrokeLineJoin(linejoin).c_str());
-        out("            strokeMiterLimit: %s\n", DSTR(style->stroke_miterlimit.value));
+        out("            strokeWidth     : %.3f\n", strokewidth);
+        out("            strokeLineCap   : %s\n",   getStrokeLineCap(linecap).c_str());
+        out("            strokeLineJoin  : %s\n",   getStrokeLineJoin(linejoin).c_str());
+        out("            strokeMiterLimit: %.3f\n", style->stroke_miterlimit.value);
         if(style->stroke_dasharray_set) {
            if(style->stroke_dashoffset_set) {
-               out("            strokeDashOffset: %s\n", DSTR(style->stroke_dash.offset));
+               out("            strokeDashOffset: %.3f\n", style->stroke_dash.offset);
            }
            out("            strokeDashArray: [ ");
-           for(int i = 0; i < style->stroke_dash.n_dash; i++ ) {
-               if(i > 0) {
+           for (int i = 0; i < style->stroke_dash.n_dash; i++ ) {
+               if (i > 0) {
                    out(", %.2lf", style->stroke_dash.dash[i]);
-               }else {
+               } else {
                    out(" %.2lf", style->stroke_dash.dash[i]);
                }
            }
            out(" ]\n");
         }
 
-        }
+    }
+    else if (style->stroke.isNone())
+        out("            stroke: null\n");
+
+    return true;
+}
+
+
+/**
+ *  Output rectangle to buffer
+ */
+bool JavaFXOutput::doRect(SPRect *item, const String &id)
+{
+    nrShapes++;
+
+    out("    /** rect %s */\n", id.c_str());
+    out("    function %s() : Rectangle {\n",id.c_str());
+    out("        Rectangle {\n");
+    //out("            id : \"%s\"\n", id.c_str());
+
+    /**
+     * Output the style information
+     */
+    if (!doStyle(SP_OBJECT_STYLE(item)))
+        return false;
+
+    out("            x : %.3f, y : %.3f\n", item->x.computed, item->y.computed);
+    out("            height : %.3f, width : %.3f\n", item->height.computed, item->width.computed);
+    out("            arcHeight : %.3f, arcWidth : %.3f\n", 2.0 * item->ry.computed, 2.0 * item->rx.computed);
+
+    // build transformation matrix:
+    Geom::Matrix const tm(sp_item_i2doc_affine(item)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0],pX[1],pY[0],pY[1],pZ[0],pZ[1]);
+    }
 
+    out("        };\n    }\n");
     return true;
 }
 
 
-#if 1
+/**
+ *  Output circle to buffer
+ */
+bool JavaFXOutput::doCircle(SPCircle *item, const String &id)
+{
+    nrShapes++;
+
+    out("    /** circle %s */\n", id.c_str());
+    out("    function %s() : Circle {\n",id.c_str());
+    out("        Circle {\n");
+    //out("            id : \"%s\"\n", id.c_str());
+
+    // Output the style information
+    if (!doStyle(SP_OBJECT_STYLE(item)))
+        return false;
+
+    out("            centerX : %.3f, centerY : %.3f\n", item->cx.value, item->cy.value);
+    out("            radius  : %.3f\n", item->rx.value);
+
+    // build transformation matrix:
+    Geom::Matrix const tm(sp_item_i2doc_affine(item)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0], pX[1], pY[0], pY[1], pZ[0], pZ[1]);
+    }
+
+    out("        };\n    }\n");
+    return true;
+}
+
+
+/**
+ *  Output ellipse to buffer
+ */
+bool JavaFXOutput::doEllipse(SPEllipse *item, const String &id)
+{
+    nrShapes++;
+
+    out("    /** ellipse %s */\n", id.c_str());
+    out("    function %s() : Ellipse {\n",id.c_str());
+    out("        Ellipse {\n");
+    //out("            id : \"%s\"\n", id.c_str());
+
+    // Output the style information
+    if (!doStyle(SP_OBJECT_STYLE(item)))
+        return false;
+
+    out("            centerX : %.3f, centerY : %.3f\n", item->cx.value, item->cy.value);
+    out("            radiusX : %.3f, radiusY : %.3f\n", item->rx.value, item->ry.value);
+
+    // build transformation matrix:
+    Geom::Matrix const tm(sp_item_i2doc_affine(item)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0],pX[1],pY[0],pY[1],pZ[0],pZ[1]);
+    }
+
+    out("        };\n    }\n");
+    return true;
+}
+
 
 /**
  *  Output the curve data to buffer
  */
-bool JavaFXOutput::doCurve(SPItem *item, const String &id)
+bool JavaFXOutput::doCurve(SPItem *item, const String &jfxid)
 {
     using Geom::X;
     using Geom::Y;
 
-    String jfxid = sanatize(id);
 
     //### Get the Shape
     if (!SP_IS_SHAPE(item))//Bulia's suggestion.  Allow all shapes
@@ -481,10 +654,13 @@
 
     nrShapes++;
 
+    gchar const *d = sp_object_getAttribute(item, "d", NULL);
     out("    /** path %s */\n", jfxid.c_str());
-    out("    private function %s() : Path {\n",jfxid.c_str());
-    out("        Path {\n");
-    out("            id: \"%s\"\n", jfxid.c_str());
+    out("    function %s() : SVGPath {\n",jfxid.c_str());
+    out("        SVGPath {\n");
+    //out("            id: \"%s\"\n", jfxid.c_str());
+    out("            content: \"%s\"\n", d);
+    out("            fillRule: FillRule.NON_ZERO\n");
 
     /**
      * Output the style information
@@ -493,9 +669,7 @@
         return false;
 
     // convert the path to only lineto's and cubic curveto's:
-    Geom::Scale yflip(1.0, -1.0);
-    Geom::Matrix tf = sp_item_i2d_affine(item) * yflip;
-    Geom::PathVector pathv = pathv_to_linear_and_cubic_beziers( curve->get_pathvector() * tf );
+    Geom::PathVector pathv = pathv_to_linear_and_cubic_beziers( curve->get_pathvector() );
 
     //Count the NR_CURVETOs/LINETOs (including closing line segment)
     guint segmentCount = 0;
@@ -505,7 +679,7 @@
             segmentCount += 1;
     }
 
-    out("            elements: [\n");
+    //out("            elements: [\n");
 
     unsigned int segmentNr = 0;
 
@@ -517,29 +691,21 @@
      * For all Subpaths in the <path>
      */
     for (Geom::PathVector::const_iterator pit = pathv.begin(); pit != pathv.end(); ++pit)
-        {
+    {
         Geom::Point p = pit->front().initialPoint();
         cminmax.expandTo(p);
-        out("                MoveTo {\n");
-        out("                    x: %s\n", DSTR(p[X]));
-        out("                    y: %s\n", DSTR(p[Y]));
-        out("                },\n");
 
         /**
          * For all segments in the subpath
          */
         for (Geom::Path::const_iterator cit = pit->begin(); cit != pit->end_closed(); ++cit)
-            {
+        {
             //### LINE
             if( dynamic_cast<Geom::LineSegment  const *> (&*cit) ||
                 dynamic_cast<Geom::HLineSegment const *> (&*cit) ||
                 dynamic_cast<Geom::VLineSegment const *> (&*cit) )
                 {
                 Geom::Point p = cit->finalPoint();
-                out("                LineTo {\n");
-                out("                    x: %s\n", DSTR(p[X]));
-                out("                    y: %s\n", DSTR(p[Y]));
-                out("                },\n");
                 nrNodes++;
                 }
             //### BEZIER
@@ -549,14 +715,6 @@
                 Geom::Point p1 = points[1];
                 Geom::Point p2 = points[2];
                 Geom::Point p3 = points[3];
-                out("                CurveTo {\n");
-                out("                    controlX1: %s\n", DSTR(p1[X]));
-                out("                    controlY1: %s\n", DSTR(p1[Y]));
-                out("                    controlX2: %s\n", DSTR(p2[X]));
-                out("                    controlY2: %s\n", DSTR(p2[Y]));
-                out("                    x: %s\n",         DSTR(p3[X]));
-                out("                    y: %s\n",         DSTR(p3[Y]));
-                out("                },\n");
                 nrNodes++;
                 }
             else
@@ -565,15 +723,19 @@
                 }
             segmentNr++;
             cminmax.expandTo(cit->finalPoint());
-            }
-        if (pit->closed())
-            {
-            out("                ClosePath {},\n");
-            }
         }
+    }
+
+    Geom::Matrix const tm(sp_item_i2doc_affine(item)); // <- _c[0],_c[1],_c[2],_c[3],_c[4],_c[5]
+    if ( !tm.isIdentity() ) {
+        Geom::Point pX = tm.xAxis();          // <- _c[0], _c[1]
+        Geom::Point pY = tm.yAxis();          // <- _c[2], _c[3]
+        Geom::Point pZ = tm.translation();    // <- _c[4], _c[5]
+        out("            transforms : Transform.affine(%.3f,%.3f,%.3f,%.3f,%.3f,%.3f)\n",
+                 pX[0],pX[1],pY[0],pY[1],pZ[0],pZ[1]);
+    }
 
-    out("            ] // elements\n");
-    out("        }; // Path\n");
+    out("        }; // SVGPath\n");
     out("    } // end path %s\n\n", jfxid.c_str());
 
     double cminx = cminmax.min()[X];
